- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# junos_netconf – Configures the Junos Netconf system service

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- This module provides an abstraction that enables and configures the netconf system service running on Junos devices. This module can be used to easily enable the Netconf API. Netconf provides a programmatic interface for working with configuration and state resources as defined in RFC 6242. If the `netconf_port` is not mentioned in the task by default netconf will be enabled on port 830 only.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
netconf_port - | Default: 830 | This argument specifies the port the netconf service should listen on for SSH connections. The default port as defined in RFC 6242 is 830. aliases: listens_on
provider dictionary |  | Deprecated Starting with Ansible 2.5 we recommend using `connection: network_cli` or `connection: netconf`. For more information please see the Junos OS Platform Options guide. A dict object containing connection details.
| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device. The port value will default to the well known SSH port of 22 (for `transport=cli`) or port 830 (for `transport=netconf`) device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
state - | Choices: present ← absent | Specifies the state of the `junos_netconf` resource on the remote device. If the state argument is set to present the netconf service will be configured. If the state argument is set to absent the netconf service will be removed from the configuration.

## Notes

Note

- Tested against vSRX JUNOS version 15.1X49-D15.4, vqfx-10000 JUNOS Version 15.1X53-D60.4.

- Recommended connection is `network_cli`. See the Junos OS Platform Options.

- This module also works with `local` connections for legacy playbooks.

- If `netconf_port` value is not mentioned in task by default it will be enabled on port 830 only. Although `netconf_port` value can be from 1 through 65535, avoid configuring access on a port that is normally assigned for another service. This practice avoids potential resource conflicts.

- For information on using CLI and netconf see the Junos OS Platform Options guide

- For more information on using Ansible to manage network devices see the Ansible Network Guide

- For more information on using Ansible to manage Juniper network devices see https://www.ansible.com/ansible-juniper.

## Examples

    - name: enable netconf service on port 830
      junos_netconf:
        listens_on: 830
        state: present

    - name: disable netconf service
      junos_netconf:
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands string | when changed is True | Returns the command sent to the remote device Sample: set system services netconf ssh port 830

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Peter Sprygada (@privateip)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.